//Run Dust
addHook("PlayerThink", function(player) 

	if not(player.mo) then return end 	

  if (player.mo.skin ~= "copper") then return end
		if (P_IsObjectOnGround(player.mo)) 
		and (player.mo.state == S_PLAY_RUN) 
		and not player.powers[pw_super]
			P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none)
	end
end) 

//Footstep sound
addHook("ThinkFrame", do
	for p in players.iterate
	     if (p.mo.state == S_PLAY_WALK) and (p.mo.frame == D or p.mo.frame == A) and P_IsObjectOnGround(p.mo)
		 and (p.mo.skin == "copper")
	        S_StartSound(p.mo, sfx_kc50)
		end
	end
end)


addHook("ThinkFrame", do
	for p in players.iterate
	     if (p.mo.state == S_PLAY_RUN) and (p.mo.frame == B) and P_IsObjectOnGround(p.mo)
		 and (p.mo.skin == "copper")
	        S_StartSound(p.mo, sfx_kc50)
		end
	end
end)

//no airwalking cuz airwalk stinky
addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "copper"
	and not P_IsObjectOnGround(player.mo)
		if player.mo.state == S_PLAY_WALK
		or player.mo.state == S_PLAY_RUN
		or player.mo.state == S_PLAY_DASH
			player.mo.state = S_PLAY_SPRING
		end
	end
end)

//Double Jump
addHook("AbilitySpecial", function(player)
    if player.mo and player.mo.skin == "copper"
	and not (player.pflags & PF_THOKKED)
		player.pflags = $1|PF_THOKKED
		P_SetObjectMomZ(player.mo,10*FRACUNIT)
		S_StartSound(player.mo, sfx_jump)
		player.mo.state = S_PLAY_ROLL
		for i = 1, 16 
			local object = P_SpawnMobjFromMobj(player.mo, 0,0,0,MT_SPINDUST)
			object.target = player.mo
			object.fuse = TICRATE
			object.scale = player.mo.scale
			object.destscale = player.mo.scale/8
			P_InstaThrust(object, i*ANGLE_22h, 20*FRACUNIT)
			object.momz = 0
		end	
	end
end)

//Uncurl, used to crouch while spinning
local UNCURL_LOCKTIME=8

COM_AddCommand("uncurltoggle",function(player,value)
	if not(player and player.valid and player.mo)
		CONS_Printf(player,"This command can only be used inside a level.")
		return
		end
	if not(player.mo.skin=="copper")
		CONS_Printf(player,"You must be playing as copper to use this command.")
		return
		end
	if value=="0"or value=="no"or value=="off"or value=="false"
		player.uncurltoggle=0
		CONS_Printf(player,"Uncurl toggle disabled.")
	elseif value=="1"or value=="yes"or value=="on"or value=="true"
		player.uncurltoggle=1
		CONS_Printf(player,"Uncurl toggle enabled.")
	else
		if player.uncurltoggle==1
			CONS_Printf(player,"uncurltoggle is on. Default is on.")
		else
			CONS_Printf(player,"uncurltoggle is off. Default is on.")
		end
	end
end,0)

addHook("ThinkFrame",function(player)
	for player in players.iterate()
		//Init
		if player.mo.skin=="copper"
			if player.init==nil
				player.init=true
				player.prevbuttons=player.cmd.buttons
				if player.uncurltoggle==nil
					player.uncurltoggle=1
					end
				return
			end
		
			if player.mo and player.playerstate==PST_LIVE and not player.exiting and not player.powers[pw_nocontrol] and not P_PlayerInPain(player)
				local pbtn=player.prevbuttons
				local btn=player.cmd.buttons
				local mo=player.mo
			
				//Uncurl
				if mo.state==S_PLAY_ROLL and P_IsObjectOnGround(mo)
					local uncurlinput=false
					local recurlinput=false
					if player.uncurltoggle==1
						uncurlinput=(btn&BT_USE)and not(pbtn&BT_USE)
					else
						uncurlinput=(pbtn&BT_USE)and not(btn&BT_USE)
						recurlinput=(btn&BT_USE)and not(pbtn&BT_USE)
					end
				
					if mo.uncurl_lock==UNCURL_LOCKTIME and uncurlinput
						uncurlinput=false
					end
				
					if uncurlinput
						mo.will_uncurl=true
					end
					if recurlinput
						mo.will_uncurl=false
					end
				
					if mo.uncurl_lock
						mo.uncurl_lock=max(0,$-1)
					
					elseif mo.will_uncurl
						mo.uncurl_lock=UNCURL_LOCKTIME
						mo.uncurlready=false
						if FixedHypot(mo.momx, mo.momy)>=player.runspeed
							mo.state=S_PLAY_RUN
						else
							mo.state=S_PLAY_WALK
						end
						if player.pflags&PF_SPINNING
							player.pflags=$1&~PF_SPINNING
						end
						S_StopSoundByID(mo,sfx_spin)
					end
				else
					mo.uncurl_lock=UNCURL_LOCKTIME
					mo.will_uncurl=false
				end
				player.prevbuttons=btn
			end
		end
	end
end)
